function [ARP_c ARR_c Fscore_c] = image_retrieval(Fea0, label, top_no, dis_type);
% 2015/11/23; rushi lan
% Fea is a M*N matrix; each row represents a feature vector;
% label is a M*1 column vector;
% ARP: average retrieval precision
% ARR: average retrieval rate

% Fea = rand(100,10);
% label = [ones(50,1); 2*ones(50,1)];
% top_no = 20;

[M N] = size(Fea0);

switch dis_type

    case 'L1'
        for m=1:M
            f = Fea0(m,:);
            temp_F = Fea0;
            temp_F(m,:) = [];
            Fea =  temp_F;
            f_label = label(m);
            F = repmat(f,M-1,1);
            temp = abs(F-Fea).^1;%./(F+Fea);
            % temp = abs(F-Fea).^2;
            dis = sum(temp,2);
            [val ind] = sort(dis, 'ascend');
            f_label_pre = label(ind(1:top_no));
            re_no = length(find(f_label_pre==f_label));
            ARP(m) = re_no/top_no;
            ARR(m) = re_no/(length(find(label==f_label))-1);
        end



    case 'L2'
        for m=1:M
            f = Fea0(m,:);
            temp_F = Fea0;
            temp_F(m,:) = [];
            Fea =  temp_F;
            f_label = label(m);
            F = repmat(f,M-1,1);
            temp = abs(F-Fea).^2;%./(F+Fea);
            % temp = abs(F-Fea).^2;
            dis = sum(temp,2);
            [val ind] = sort(dis, 'ascend');
            f_label_pre = label(ind(1:top_no));
            re_no = length(find(f_label_pre==f_label));
            ARP(m) = re_no/top_no;
            ARR(m) = re_no/(length(find(label==f_label))-1);
        end

    case 'inter_sec'
        for m=1:M
            f = Fea0(m,:);
            temp_F = Fea0;
            temp_F(m,:) = [];
            Fea =  temp_F;
            f_label = label(m);

            [mm nn] = size(Fea);
            simi = zeros(mm,1);
            for k=1:mm
                temp_k = [f;Fea(k,:)];
                simi(k) = sum(min(temp_k));
            end

            [val ind] = sort(simi, 'descend');
            f_label_pre = label(ind(1:top_no));
            re_no = length(find(f_label_pre==f_label));
            ARP(m) = re_no/top_no;
            ARR(m) = re_no/(length(find(label==f_label))-1);
        end

end

ARP_all = ARP; 
ARP = mean(ARP);
ARR_all = ARR;
ARR = mean(ARR);


C_num = max(label(:));
for i=1:C_num
    posi = find(label==i);
    ARP_C(i) = mean(ARP_all(posi));
    ARR_C(i) = mean(ARR_all(posi));
end

ARP_c = mean(ARP_C);
ARR_c = mean(ARR_C);
Fscore_c = 2*ARP_c*ARR_c/(ARP_c+ARR_c);


