function scattering_codewords_generation();
%
% represent each sub-image by its column projection value, and then generate the
% codeword

clear, clc, close all

% db_name = 'tcia_ct'; class_num = 8;
% db_name = 'exact09'; class_num = 19;
db_name = 'nema_ct_tip'; class_num = 9;

path0 = ['\scatter_representation\' db_name '\'];
labels = dlmread([path0 db_name '_labels.txt']);
num = 3;    % image number per class use to generate codewords


used_index = [];

for i=1:class_num
    posi = find(labels==i);
    temp = length(posi);
    posi_1 = randperm(temp);
    used_posi = posi(posi_1(1:num));
    used_index = [used_index; used_posi];
end

scatter_data = [];
index = 0;
for i=1:length(used_index)
    i;
    data = load([path0 db_name '_' num2str(used_index(i))]);
    data = data.temp;
    temp_sig = data{1,3}.signal;
    temp_theta = data{1,3}.meta.theta(2,:);
    for j=1:length(temp_sig)
        coef = temp_sig{j};
        coef = double(coef);
        coef = sum(coef);
        index = index + 1;
        scatter_data(index,:) = coef;
    end
end

[cidx, ctrs] = kmeans(scatter_data, 200);
dlmwrite(['nema_ct_tip_codewords_3_200_2.txt'], ctrs);




